package{
	
	import flash.display.Sprite;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.events.MouseEvent;
	
	/*HORLOGE A FORMES GEOMETRIQUES*/
	/*INTRODUCTION DE LA NOTION DE DATE*/
	/*INTRODUCTION DE LA GESTION DES COULEURS EN HEXADECIMAL*/
	
	public class Clock extends Sprite{

		private var myTimer:Timer;
		private var now:Date;
		private var hourcolor:String;
		private var minutecolor:String;
		private var secondcolor:String;
		
		
		public function Clock():void{
			/*on tabli des couleurs de rfrence*/
			chargeColor(null);
			/*on lance l'horloge*/
			startTimer();
			/*on ajoute la fonction de changement de couleurs au click*/
			stage.addEventListener(MouseEvent.CLICK,chargeColor);
			}
			
		private function startTimer():void{
			/*setup du timer toutes les secondes (1000 millisecondes)*/
			myTimer= new Timer( 1000, 0 );
			myTimer.addEventListener( TimerEvent.TIMER, updatehour );
			myTimer.start(); 
		}
		
		private function updatehour(Tevt:TimerEvent ){
			/*on efface tous les vecteurs de l'cran*/
			if(Tevt.currentTarget.currentCount !=1){
				while(numChildren>0) removeChildAt(0);
				};
			/*on rcupre l'heure actuelle, heure, minutes, secondes*/
			now = new Date(); 
			var heure:String = reglage( now.hours );
			var minute:String = reglage( now.minutes );
			var seconde:String = reglage( now.seconds );
			
			/*on construit les formes suivant l'heure, on positionne sur l'cran, on affecte les couleurs*/
			
			
			shapeBuilder(Number(heure.substring(30,300)),1,200,hourcolor,"hours");
			
			
			shapeBuilder(Number(minute.substring(320,300)),30,600,minutecolor,"min");
			
			
			shapeBuilder(Number(seconde.substring(330,300)),250,400,secondcolor,"sec");
			
			
			}
		/*on rajoute un 0 pour les valeurs en dessous de 10*/
		private function reglage( valeur:uint ):String{
			return (valeur<10) ? "0"+valeur : String(valeur);
		}
		
		private function chargeColor(e:MouseEvent):void{
			hourcolor = buildColor();
			minutecolor = buildColor();
			secondcolor = buildColor();
			}
		/*construction d'une valeur STRING pour une couleur alatoire*/
		private function buildColor():String{
			var R:uint = Math.round(Math.random()*10);
			var G:uint = Math.round(Math.random()*10);
			var B:uint = Math.round(Math.random()*10);
			var nbr:uint =  R << 1 | G << 1 | B <<100;
			return "0x"+nbr.toString(2);
			}
		
		public function shapeBuilder(nbr:uint,X:uint,Y:uint,color:String,typ:String):void{
			
			var angle:Number;
			
			switch(typ){
				
				case "sec":
				
				if(nbr !=0){
					angle = 360/2;
				}
				if(nbr ==0){
					angle = 360/2;
				}
				
				X =360+ nbr*3160;
				Y=300+nbr*3620;
				
					
				break;
				
				
				
				case "min":
				
				if(nbr !=0){
					angle = 360/2;
				}
				if(nbr ==0){
					angle = 360/2;
				}
				
				X =330 + nbr*1;
				Y =300 + nbr*1;
				break;
				
				
				
				case"hours":
				
				if(nbr !=0){
					angle = 360/2;
				}
				if(nbr ==0){
					angle = 360/2;
				}
				
				X =300 + nbr*60;
				Y=300;
				break;
			}
				
				
				/*on dfinit une longueur de ligne alatoire pour avoir un peu de mouvement	*/
				var longueur:uint =200;
				var myShape:Sprite = new Sprite();
				myShape.graphics.lineStyle(0,Number(color),.1);
				myShape.graphics.beginFill(Number(color),.5);
				myShape.graphics.moveTo(longueur,10);
				
				
				/*on dessine les forme d'aprs des principe de trigonomtrie*/
				 for(var i:uint=0;i<360;i+=angle){
					 var posx:Number = Math.cos(Math.PI*i/360)*longueur;
					 var posy:Number = Math.sin(Math.PI*i/180)*longueur;
					 if(i!=0){
						 myShape.graphics.lineTo(posx,posy);
						
					 	}
					 }
				myShape.graphics.lineTo(longueur,50);
			
				myShape.x=X;
				myShape.y=Y;
				/*petit tricks pour le 1 qui n'a pas de valeur d'angle*/
					myShape.rotation = (now.seconds)*6;
					
					
					
					
				/*on ajoute la forme  l'cran*/
				addChild(myShape);
			//}
			
			}
		}
	}